/*###############################################################################
# Linux Management Providers (LMP), PCI provider package
# Copyright (C) 2009 Nazarov Nodir, TUIT <nazarov.nodir@gmail.com, nodir2000@yahoo.com>
#
# This program is being developed under the "OpenDRIM" project.
# The "OpenDRIM" project web page: http://opendrim.sourceforge.net
# The "OpenDRIM" project mailing list: opendrim@googlegroups.com
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; version 2
# of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#################################################################################

#################################################################################
# To contributors, please leave your contact information in this section
# AND comment your changes in the source code.
#
# Modified by 2009 Guillaume BOTTEX, ETRI <guillaumebottex@etri.re.kr>
###############################################################################*/

#include "cmpiOpenDRIM_MemberOfPCICollection.h"

CMPIObjectPath* PCI_OpenDRIM_MemberOfPCICollection_toCMPIObjectPath(const CMPIBroker* broker, const OpenDRIM_MemberOfPCICollection& instance) {
	_E_;
	Objectpath op(broker, OpenDRIM_MemberOfPCICollection_classnames[0], OpenDRIM_MemberOfPCICollection_NAMESPACE);

	if (!instance.Collection_isNULL)
		op.addKey("Collection", instance.Collection);

	if (!instance.Member_isNULL)
		op.addKey("Member", instance.Member);

	_L_;
	return op.getHdl();
}

CMPIInstance* PCI_OpenDRIM_MemberOfPCICollection_toCMPIInstance(const CMPIBroker* broker, const OpenDRIM_MemberOfPCICollection& instance) {
	_E_;
	Objectpath op(broker, PCI_OpenDRIM_MemberOfPCICollection_toCMPIObjectPath(broker, instance));
	Instance ci(broker, op);

	_L_;
	return ci.getHdl();
}

void PCI_OpenDRIM_MemberOfPCICollection_toCPP(const CMPIBroker* broker, const CMPIObjectPath* ref, OpenDRIM_MemberOfPCICollection& instance) {
	_E_;
	Objectpath op(broker, (CMPIObjectPath*) ref);

	if (op.getKey("Member", instance.Member) == OK)
		instance.Member_isNULL = false;

	if (op.getKey("Collection", instance.Collection) == OK)
		instance.Collection_isNULL = false;

	_L_;
}

void PCI_OpenDRIM_MemberOfPCICollection_toCPP(const CMPIBroker* broker, const CMPIInstance* ci, OpenDRIM_MemberOfPCICollection& instance) {
	_E_;
	Instance inst(broker, (CMPIInstance*) ci);

	if (inst.getProperty("Collection", instance.Collection) == OK)
		instance.Collection_isNULL = false;

	if (inst.getProperty("Member", instance.Member) == OK)
		instance.Member_isNULL = false;

	_L_;
}

