/*###############################################################################
# Linux Management Providers (LMP), PCI provider package
# Copyright (C) 2009 Nazarov Nodir, TUIT <nazarov.nodir@gmail.com, nodir2000@yahoo.com>
#
# This program is being developed under the "OpenDRIM" project.
# The "OpenDRIM" project web page: http://opendrim.sourceforge.net
# The "OpenDRIM" project mailing list: opendrim@googlegroups.com
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; version 2
# of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#################################################################################

#################################################################################
# To contributors, please leave your contact information in this section
# AND comment your changes in the source code.
#
# Modified by 2009 Guillaume BOTTEX, ETRI <guillaumebottex@etri.re.kr>
###############################################################################*/

#ifndef CMPIOPENDRIM_PCIBRIDGE_H_
#define CMPIOPENDRIM_PCIBRIDGE_H_

#include "OpenDRIM_PCIBridge.h"

CMPIObjectPath* PCI_OpenDRIM_PCIBridge_toCMPIObjectPath(const CMPIBroker* broker, const OpenDRIM_PCIBridge& instance);

CMPIInstance* PCI_OpenDRIM_PCIBridge_toCMPIInstance(const CMPIBroker* broker, const OpenDRIM_PCIBridge& instance);

void PCI_OpenDRIM_PCIBridge_toCPP(const CMPIBroker* broker, const CMPIObjectPath* ref, OpenDRIM_PCIBridge& instance);

void PCI_OpenDRIM_PCIBridge_toCPP(const CMPIBroker* broker, const CMPIInstance* ci, OpenDRIM_PCIBridge& instance);

void PCI_OpenDRIM_PCIBridge_toCPP(const CMPIBroker* broker, const CMPIArgs* in, OpenDRIM_PCIBridge_RequestStateChange_In& args);

void PCI_OpenDRIM_PCIBridge_toCMPIArg(const CMPIBroker* broker, CMPIArgs* out, const OpenDRIM_PCIBridge_RequestStateChange_Out& args);

void PCI_OpenDRIM_PCIBridge_toCPP(const CMPIBroker* broker, const CMPIArgs* in, OpenDRIM_PCIBridge_SetPowerState_In& args);

void PCI_OpenDRIM_PCIBridge_toCPP(const CMPIBroker* broker, const CMPIArgs* in, OpenDRIM_PCIBridge_EnableDevice_In& args);

void PCI_OpenDRIM_PCIBridge_toCPP(const CMPIBroker* broker, const CMPIArgs* in, OpenDRIM_PCIBridge_OnlineDevice_In& args);

void PCI_OpenDRIM_PCIBridge_toCPP(const CMPIBroker* broker, const CMPIArgs* in, OpenDRIM_PCIBridge_QuiesceDevice_In& args);


#endif /*CMPIOPENDRIM_PCIBRIDGE_H_*/
